package com.schisandra.oss.application.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Preconditions;
import com.schisandra.oss.application.convert.SchisandraOssUpDTOConverter;
import com.schisandra.oss.application.dto.SchisandraOssUpDTO;
import com.schisandra.oss.common.entity.Result;
import com.schisandra.oss.domain.bo.SchisandraOssUpBO;
import com.schisandra.oss.domain.service.SchisandraOssUpDomainService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 又拍云对象存储配置表 controller
 *
 * @author landaiqing
 * @since 2024-06-02 22:29:27
 */
@RestController
@RequestMapping("/oss/up/")
@Slf4j
public class SchisandraOssUpController {

    @Resource
    private SchisandraOssUpDomainService schisandraOssUpDomainService;

    /**
     * 新增又拍云对象存储配置表
     */
    @RequestMapping("add")
    public Result<Boolean> add(@RequestBody SchisandraOssUpDTO schisandraOssUpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssUpController.add.dto:{}", JSON.toJSONString(schisandraOssUpDTO));
            }
            Preconditions.checkNotNull(schisandraOssUpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPassword(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTimeout(), "默认的超时时间：30秒不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getApiDomain(), "默认为自动识别接入点不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssUpBO SchisandraOssUpBO = SchisandraOssUpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssUpDTO);
            return Result.ok(schisandraOssUpDomainService.add(SchisandraOssUpBO));
        } catch (Exception e) {
            log.error("SchisandraOssUpController.register.error:{}", e.getMessage(), e);
            return Result.fail("新增又拍云对象存储配置表失败");
        }

    }

    /**
     * 修改又拍云对象存储配置表
     */
    @RequestMapping("update")
    public Result<Boolean> update(@RequestBody SchisandraOssUpDTO schisandraOssUpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssUpController.update.dto:{}", JSON.toJSONString(schisandraOssUpDTO));
            }
            Preconditions.checkNotNull(schisandraOssUpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPassword(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTimeout(), "默认的超时时间：30秒不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getApiDomain(), "默认为自动识别接入点不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssUpBO schisandraOssUpBO = SchisandraOssUpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssUpDTO);
            return Result.ok(schisandraOssUpDomainService.update(schisandraOssUpBO));
        } catch (Exception e) {
            log.error("SchisandraOssUpController.update.error:{}", e.getMessage(), e);
            return Result.fail("更新又拍云对象存储配置表信息失败");
        }

    }

    /**
     * 删除又拍云对象存储配置表
     */
    @RequestMapping("delete")
    public Result<Boolean> delete(@RequestBody SchisandraOssUpDTO schisandraOssUpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssUpController.delete.dto:{}", JSON.toJSONString(schisandraOssUpDTO));
            }
            Preconditions.checkNotNull(schisandraOssUpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUserName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPassword(), "不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTimeout(), "默认的超时时间：30秒不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getApiDomain(), "默认为自动识别接入点不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssUpDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssUpBO schisandraOssUpBO = SchisandraOssUpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssUpDTO);
            return Result.ok(schisandraOssUpDomainService.delete(schisandraOssUpBO));
        } catch (Exception e) {
            log.error("SchisandraOssUpController.delete.error:{}", e.getMessage(), e);
            return Result.fail("删除又拍云对象存储配置表信息失败");
        }

    }

}
